﻿#-------------------------------------------------------------------------------
# Name:        Aliens Tk Spm v0.26
# Purpose:     Education Game
#
# Author:      Serge Smeesters, alias Spaceeman
#
# Created:     2023-02-19
# Copyright:   (c) Serge Smeesters 2023
# Licence:     GPL3
#-------------------------------------------------------------------------------

import tkinter as tk
import math as ma
import time as T
import random as R
import re

from mytools import minmax, is_out, signe, Avg


tk_images = dict()
def tk_image( iname ) :
    global tk_images
    if iname not in tk_images :
        tk_images[ iname ] = tk.PhotoImage( file="images/"+iname )
    return tk_images[ iname ]


class Updatable :
    toadd = set()
    items = set()
    todel = set()
    lt = T.time()
    ct = T.time()

    def __init__( self ) :
        Updatable.toadd.add( self )

    def update_all() :
        ct = T.time()
        dt = ct - Updatable.lt
        while Updatable.todel :
            i = Updatable.todel.pop()
            Updatable.items.remove( i )
        while Updatable.toadd :
            i = Updatable.toadd.pop()
            Updatable.items.add( i )
        Updatable.ct = ct
        for i in Updatable.items :
            i.update( dt )
        Updatable.lt = ct

    def bey( self ) : Updatable.todel.add( self )
#
# class Updatable


class Stars( Updatable ) :
    def __init__( self, nbs=100 ) :
        Updatable.__init__( self )
        global starsi
        starsi = list()

        vy = 10
        img = tk_image( "bac01.gif" )
        r = img.height() / 2
        (x, y) = ( R.random()*ww, 0 )
        id = cv.create_image( x, y, image = img )
        starsi.append( [x, y, vy, r, id] )
        (x, y) = ( R.random()*ww, wh/2 + r)
        id = cv.create_image( x, y, image = img )
        starsi.append( [x, y, vy, r, id] )

        for i in range( nbs ) :
            bri = R.random()*.7+.3
            vy = bri*50
            imgi = 1 if bri < .4 else 2 if bri < .7 else 3 if bri < .9 else 4
            img = tk_image( "star0%i.gif"%(imgi) )
            r = img.height() / 2
            (x, y) = ( R.random()*ww, R.random()*wh )
            id = cv.create_image( x, y, image = img )
            r = img.height() / 2
            starsi.append( [x, y, vy, r, id] )

    def update( self, dt ) :
        global starsi
        for si in starsi :
            (x, y, vy, r, id) = si
            dy = vy*dt
            y += dy
            if (y - r) > wh :
                y = -r
                x = R.random()*ww
                si[0] = x
            si[1] = y
            cv.coords( id, x, y )
#
# class Stars

class Infos( Updatable ) :
    def __init__( self, x=100, y=100 ) :
        Updatable.__init__( self )
        (self.x, self.y) = (x, y)
        self.l = tk.Label( text="Coucou" )
        self.wid = cv.create_window( x, y, window=self.l )
        self.hi = cv.create_rectangle( 0, 0, 20, 100, fill='red', outline='red' )
        self.pi = cv.create_rectangle( 25, 0, 45, 100, fill='blue', outline='blue' )
        self.bi = cv.create_rectangle( 50, 0, 70, 100, fill='yellow', outline='yellow' )
        self.biis = list()

    def __del__( self ) : cv.delete( self.wid )

    def update( self, dt ) :
        global adt
        dt = adt()
        txt = "%.1f fps"%( 1.0 / dt ) if dt else "? fps"
        self.l.configure( text = txt )
        cv.coords( self.hi, 0, 100 - ship.health, 20, 100 )
        cv.coords( self.pi, 25, 100 - ship.power, 45, 100 )
        cv.coords( self.bi, 50, 100 - ship.bulets*5, 70, 100 )
        nbulets = int( ship.bulets )
        nbulimg = len( self.biis )
        while nbulimg < nbulets :
            self.biis.append(
                cv.create_image( 60, 95 - nbulimg * 5, image = tk_image( "bulletv.gif" ) ) )
            nbulimg += 1
        while nbulimg > nbulets :
            cv.delete( self.biis.pop() )
            nbulimg -= 1
#
# class Infos


class Sprite( Updatable ) :
    sprites = set()
    def __init__( self, iname, x=100, y=100, r=None ) :
        Updatable.__init__( self )
        Sprite.sprites.add( self )
        ( self.x, self.y ) = ( x, y )
        self.img = tk_image( iname )
        self.r = r if r else (self.img.height() + self.img.width() ) / 4
        self.iid = cv.create_image( x, y, image = self.img )
        self.t = 0.0

    def __del__( self ) :
        if self.iid : cv.delete( self.iid ) ; self.iid = None
        if self in Sprite.sprites : Sprite.sprites.remove( self )

    def image_set( self, iname, r=None ) :
        newimg = tk_image( iname )
        if not self.img is newimg :
            cv.itemconfigure( self.iid, image = newimg )
            self.img = newimg
            self.r = r if r else (self.img.height() + self.img.width() ) / 4

    def bey( self ) :
        if self.iid : cv.delete( self.iid ) ; self.iid = None
        Updatable.bey( self )

    collisions = dict()
    def find_collisions() :
        newsprites = set()
        collisions = dict()
        while Sprite.sprites :
            a = Sprite.sprites.pop()
            if not a.iid : continue
            for b in Sprite.sprites :
                if not b.iid : continue
                if abs(a.x - b.x) > (a.r + b.r) : continue
                if abs(a.y - b.y) > (a.r + b.r) : continue
                d = ma.hypot( a.x - b.x , a.y - b.y )
                if d < ( a.r + b.r ) :
                    if a in collisions : ac = collisions[a]
                    else : collisions[a] = ac = set()
                    ac.add( b )
                    if b in collisions : bc = collisions[b]
                    else : collisions[b] = bc = set()
                    bc.add( a )
            newsprites.add( a )
        Sprite.collisions = collisions
        Sprite.sprites = newsprites

    def move_( self, dx, dy ) :
        if not self.iid : return
        cv.move( self.iid, dx, dy )
        self.x += dx ; self.y +=dy

    def moveto2( self, x, y ) :
        if not self.iid : return
        dx, dy = x- self.x, y-self.y
        cv.move( self.iid, dx, dy )
        self.x, self.y = x, y

    def moveto( self, x, y ) :
        if not self.iid : return
        cv.coords( self.iid, x, y )
        self.x, self.y = x, y

    def hitby( self, other ) : pass
#
# class Sprite


class Flyer( Sprite ) :
    def __init__( self, x, y, vx=0, vy=0, life=1 ) :
        Sprite.__init__( self, "flyer0.gif" if life > 1 else "flyer1.gif",
            x, y )
        self.life = life + R.random() *.4
        (self.vx, self.vy) = (vx, vy)

    def explosion( x, y, n=10, r=2 ) :
        n += R.randint(0,r+1)
        for i in range( n ) :
            Flyer(
                x + R.random()*10 -5, y + R.random()*10 -5,
                R.random()*n*2 -(n/2), R.random() *n*2 -(n/2), 2
            )

    def update( self, dt ) :
        if not self.iid : return
        self.life -= dt
        if self.life < 0 : self.bey() ; return
        if self.life < 1.5 : self.image_set("flyer1.gif")
        if self.life < 1 : self.image_set("flyer2.gif")
        self.vy = max( 10, self.vy + 20 * dt )
        self.x += dt*self.vx ; self.y += dt*self.vy
        self.moveto( self.x, self.y )

    def hitby( self, other ) :
        if isinstance( other, Bullet ) : self.bey()


class Meteor( Sprite ) :
    def __init__( self, x, y ) :
        Sprite.__init__( self, "meteor.gif", x, y, 8 )
        self.vy = 150
        self.vx = R.random()*6.-3.
        self.health = 20

    def update( self, dt ) :
        if not self.iid : return
        self.x += self.vx*dt ; self.y += self.vy*dt
        if is_out( 0, self.y, wh ) or is_out( 0, self.x, ww ) : self.bey()
        self.moveto( self.x, self.y )
        if self in Sprite.collisions :
            others = Sprite.collisions[ self ]
            for o in others :
                if isinstance( o, Flyer ) :
                    self.health -= 1
                    self.vy *= .98 ; self.vx += R.random()*10.-5.
                    o.hitby( self )
                elif isinstance( o, Ship ) :
                    self.health -= 20 ; o.hitby( self )
            if self.health < 1 :
                Flyer.explosion( self.x, self.y, 20 )
                self.bey()
                return
        if R.random()/dt < 2 :
            Flyer( self.x + R.random()*10 -5, self.y - self.r*2,
                R.random() * 40 -20, self.vy *R.random()*(-.2) )

    def hitby( self, other ) :
        if not self.iid : return
        if isinstance( other, Bullet ) :
            self.health -= 20 + R.random()*2
#
# class Meteor


class Alien( Sprite ) :
    def __init__( self ) :
        x = ww/2 + ww/2 * (.6 - R.random()*1.2)
        y = ( wh/2 + wh/2 * (.6 - R.random()*1.2) ) * 0.7
        Sprite.__init__( self, "alien.gif", x, y )
        self.rx = (min(x, ww - x) - self.r) * (.4 + R.random()*.6)
        self.ry = (min(y, wh*.7 - y) - self.r) * (.4 + R.random()*.6)
        (self.ax, self.ay) = ( R.random()*2*ma.pi, R.random()*2*ma.pi )
        self.vx = .5 * (.3 + R.random() *.7)
        self.vy = .5 * (.3 + R.random() *.7)
        (self.cx, self.cy) = (x, y)
        self.t = 0
        self.health = 2

    def update( self, dt ) :
        if not self.iid : return
        self.moveto(
            self.cx + self.rx * ma.cos( self.ax + self.t * self.vx ) ,
            self.cy + self.ry * ma.sin( self.ay + self.t * self.vy )
        )
        self.t += dt
        if R.random()/dt < .05 : Meteor( self.x, self.y+10 )

    def hitby( self, other ) :
        if not self.iid : return
        self.health -= 1
        if self.health < 1 :
            Flyer.explosion( self.x, self.y, 30 )
            self.bey()
        else : self.image_set( "alien2.gif" )
#
# class Alien


class Bullet( Sprite ) :
    def __init__( self, x ) :
        Sprite.__init__( self, "bullet.gif", x, wh -64, 8 )
        self.vy = -200
        self.vx = R.random()*6.-3.
        self.health = 5

    def update( self, dt ) :
        if not self.iid : return
        self.x += self.vx*dt ; self.y += self.vy*dt
        if is_out( 0, self.y, wh ) or is_out( 0, self.x, ww ) : self.bey()
        self.moveto( self.x, self.y )
        if self in Sprite.collisions :
            others = Sprite.collisions[ self ]
            for o in others :
                if isinstance( o, Flyer ) :
                    self.health -= 1
                    self.vy *= .9 ; self.vx += R.random()*40.-20.
                    o.hitby( self )
                    if self.vx > 30 : self.image_set( "bulletD.gif", 8 )
                    elif self.vx < -30 : self.image_set( "bulletG.gif", 8 )
                elif isinstance( o, (Alien, Meteor) ) :
                    self.health -= 10 ; o.hitby( self )
            if self.health < 1 :
                Flyer.explosion( self.x, self.y, 10 )
                self.bey()
                return
        if R.random()/dt < 1 :
            Flyer( self.x + R.random()*10 -5, self.y + self.r*2,
                R.random() * 40 -20, self.vy *R.random()*.5 )
#
# class Bullet


shiptheme="ship-white"
class Ship( Sprite ) :
    def __init__( self ) :
        Sprite.__init__( self, shiptheme+".gif", ww/2, wh -50 )
        self.tx = self.x
        self.vx = 0
        self.ax = 0
        self.axmax = 300
        self.vxmax = 150
        self.bulets = 10.
        self.health = 100
        self.power = 100

    def target( self, x ) : self.tx = minmax( self.r, x, ww-self.r )

    def update( self, dt ) :
        self.power = min( self.power + dt * 50., 100 )

        tdx = self.tx - self.x

        if self.power < 2 :
            self.ax = 0
        else :
            self.ax = minmax( -self.axmax, (tdx - self.vx)*5 , self.axmax )
            if signe(self.ax) == signe(self.vx) and (abs(self.vx) - self.vxmax) <.01 :
                self.ax /= 2
            self.power -= abs(self.ax) * dt * .4

        self.vx = minmax( -self.vxmax, self.vx + self.ax*dt, self.vxmax )
        self.x += dt*self.vx
        self.moveto( self.x, self.y )
        if self.ax < self.axmax*(-.8) : self.image_set( shiptheme+"D1.gif")
        elif self.ax < self.axmax*(-.1) : self.image_set( shiptheme+"D0.gif")
        elif self.ax < self.axmax*.1 : self.image_set( shiptheme+".gif")
        elif self.ax < self.axmax*.8 : self.image_set( shiptheme+"G0.gif")
        else : self.image_set( shiptheme+"G1.gif")
        if R.random()/dt < ( abs( self.ax ) / self.axmax )*10 :
            Flyer( self.x - signe(self.ax) * self.r, self.y + R.random()*30 -15,
                -self.ax, R.random() * 40 -20 )

        if self.health < 1 :
            Flyer.explosion( self.x, self.y, 100 )
            self.bey()
            return

        if self.power > 30 and self.health < 100:
            self.health = min( self.health + dt*10 ,100 )
            self.power -= dt *30

        if self.power > 80 and self.bulets < 20 :
            self.bulets = min( self.bulets + dt*2, 20)
            self.power -= dt * 20


    def fire( self ) :
        if self.power < 10 : return
        if self.bulets < 1 : return
        Bullet( self.x )
        self.bulets -= 1.
        self.power -= 5.

    def hitby( self, other ) :
        self.health -= R.random()*20 + 20


def click( event ) :
    print("click")
    if event.num == 1 and ship : ship.target( event.x )
    if event.num == 3 and ship : ship.fire()

kleft = False
kright = False
kspace = False
def keypress( event ) :
    global kspace, kleft, kright

    if event.keysym == 'Escape' : root.destroy() ; return

    if event.keysym == 'Left' : kleft = True
    elif event.keysym == 'Right' : kright = True
    elif event.keysym == 'space' and not kspace :
        kspace = True
        ship.fire()

    if event.keysym in ('Left', 'Right') :
        if kleft and not kright : ship.target( 0 )
        elif kright and not kleft : ship.target( ww )

def keyrelease( event ) :
    global kspace, kleft, kright

    if event.keysym == 'Left' : kleft = False
    elif event.keysym == 'Right' : kright = False
    elif event.keysym == 'space' : kspace = False

    if event.keysym in ('Left', 'Right') :
        if not kleft and not kright : ship.target( ship.x )
        elif kleft : ship.target( 0 )
        elif kright : ship.target( ww )

root = tk.Tk()
root.title("Aliens")
sw = root.winfo_screenwidth()
sh = root.winfo_screenheight()
ww = min( 1024, (sw // 40)*32 )
wh = min( 800, (sh // 40)*32 )
root.geometry("%ix%i"%(ww,wh))
root.columnconfigure(0, weight=1)
root.rowconfigure(0, weight=1)
cv = tk.Canvas(root, bg="black")
cv.grid(column=0, row=0, sticky=(tk.N, tk.W, tk.E, tk.S))
cv.bind("<Button-1>",click)
cv.bind("<Button-3>",click)
root.bind('<KeyPress>', keypress)
root.bind('<KeyRelease>', keyrelease )

t1 = T.time()
adt = Avg(10)
def update_timer() :
    global t1, adt
    Updatable.update_all()
    Sprite.find_collisions()
    t2 = T.time()
    dt = t2 - t1 ; adt.put( dt )
    t1 = t2
    root.after( max(1,int(33.0-dt*1000)), update_timer )

ship = None
def game_start() :
    global ship, t1
    Stars(100)
    ship = Ship()
    nbaliens = 30
    for i in range( nbaliens ) : Alien()
    Infos( ww/2, 20 )
    t1 = T.time()
    root.after( 1, update_timer )

root.after( 1000, game_start )
root.mainloop()
